<?php
define(TARGETDB,'c:/dvpactivedb.db');
define(BACKUPDB,'d:/dvpbackupdb.db');
define(LOGFILE,'c:/backupDaemon.log');
define(BACKUPINTERVAL,3600);
define(ERR_CD1,'Impossible d\'ouvrir le fichier Log');
define(ERR_CD2,'La base de donnes  sauvegarder n\'a pu tre trouve');
define(ERR_CD3,'Impossible de copier la base de donne');

class BackupDaemon
{
 private $logFileRes=null;

	function __construct()
	{
            $this->startDaemon();
	}

	private function startDaemon()
	{
	 $x = win32_start_service_ctrl_dispatcher('PHP_BackupDB');
         $sleepTime=1;
         $this->backupDB(); /* On commence par effectuer un backup directement */
	 /*
            La condition de cette boucle sert  vrifier qu'on a pas tent de stopper
            le service dans le SCM. Il ne faut donc pas trop dormir trop longtemps(sleep) sous peine que l'utilisateur
            ne puisse stopper le service.
         */
	 while (WIN32_SERVICE_CONTROL_STOP != win32_get_last_control_message()) {

                if($sleepTime == BACKUPINTERVAL)
                {
                	$sleepTime=1;
                	$this->backupDB();
                }
                sleep(1);
                $sleepTime++;
	 }
	}

        private function backupDB()
        {
        	if(!file_exists(TARGETDB))
        	{
        	 $this->handleError(ERR_CD2);
        	}

        	if(!(copy(TARGETDB,BACKUPDB)))
        	{
        	  $this->handleError(ERR_CD3);
        	}
                $this->logIt('Dernier backup effectu correctement:'.date('y/m/d h:i:s'));

        }
	private function logIt($msg)
	{
	 if(!is_resource($this->logFileRes))
	 {
	 	$this->logFileRes=fopen(LOGFILE,'a+') or $this->handleError();
	 }
	 fwrite($this->logFileRes,$msg."\r\n");
	}

	private function handleError($err)
	{
              if($err != ERR_CD1)
              {
              	$this->logIt($err);
              }
              $this->__destruct();
	}
	function __destruct()
	{       /* Si le fichier log a t correctement ouvert, on le ferme */
		if(is_resource($this->logFileRes))
		{
			fclose($this->logFileRes);
		}
		die();
	}


}

/* On vrifie que l'extension est charge, si elle ne l'est pas, on la charge*/
if(!extension_loaded('php_win32service'))
{
  dl('php_win32service.dll') or die('Impossible de charger la librairie php_win32service.dll');
}

/* On vrifie les paramtres passs au script */
if(isset($argv[1]))
{
 $validParams=array('install','uninstall');
 if(!in_array($argv[1],$validParams))
 {
  die('Veuillez specifier install || uninstall comme premier parametre');
 }

 if ($argv[1] == 'install') {
         /*
            Cration du service dans le SCM (service control manager)
            La fonction win32_create_service cre le service dans le SCM. Le nom du service
            est donn en tant que premier paramtre, le label qu'il aura dans le SCM dans le second
            et le fichier qu'il devra lancer ainsi que l'argument run dans le 3me paramtre.
         */
	$createService = win32_create_service(array(
		'service' => 'PHP_BackupDB',
		'display' => 'Exemple de dmon DVP',
		'params' => __FILE__,
	));
        if($createService !== true)
        {
        	die('Impossible de crer le service!');
        }
        else
        {
        	die('Service cree avec succes');
        }

 } 
 else if ($argv[1] == 'uninstall') 
 {
        /* win32_delete_service marque le service comme "disabled/dsactiv" dans le SCM. */
	$removeService = win32_delete_service('PHP_BackupDB');
        switch($removeService)
        {
        	case 1060: die('Ce service n\'existe pas');break;
        	case 1072: die('Ce service n\'a pu tre supprim, il est probablement actif ou corrompu!');break;
        	case 0:die('Service supprime avec succes');break;
        	default:die();break;
        }

 }
}
else
{
 $daemon=new BackupDaemon();
}

?>

